<?php
/**
 * @package		Invoicing
 * @copyright	Copyright (C) 2010-2014 Juloa.com. All rights reserved.
 * @license GNU General Public License version 3, or later
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

require_once(JPATH_ADMINISTRATOR.'/components/com_invoicing/assets/paymentplugin.php');

class plgInvoicingpaymentAtos extends InvoicingAbstractPaymentPlugin
{
    var $sync_currencies = array(
		'EUR'=>'978','USD'=>'840','GBP'=>'826','JPY'=>'392','CAD'=>'124','AUD'=>'036','CHF'=>'756',
		'MXN'=>'484','TRY'=>'949','NZD'=>'554','NOK'=>'578','BRL'=>'986','ARS'=>'032','KHR'=>'116',
		'TWD'=>'901','SEK'=>'752','DKK'=>'208','KRW'=>'410','SGD'=>'702','XAF'=>'952'
	);
    
    var $cards = array(
		'CB','VISA','MASTERCARD','AMEX','DINERS','FINAREF','FNAC','CYRILLUS',
		'PRINTEMPS','KANGOUROU','SURCOUF','POCKETCARD','CONFORAMA','NUITEA','AURORE',
		'PASS','PLURIEL','TOYSRUS','CONNEXION','HYPERMEDIA','DELATOUR','NORAUTO','NOUVFRONT',
		'SERAP','BOURBON','COFINOGA','COFINOGA_BHV','COFINOG _CASINOGEANT','COFINOGA_DIAC',
		'COFINOGA_GL','COFINOGA_GOSPORT','COFINOGA_MONOPRIX','COFINOGA_MRBRICOLAGE','COFINOGA_SOFICARTE',
		'COFINOGA_SYGMA','JCB','DELTA','SWITCH','SOLO'
	);
	
	var $messageEng = array(
		'invalid_transaction' => 'Invalid transaction', 'invalid_amount' => 'Invalid amount', 'refused_payment' => 'Refused payment',
		'invalid_card_number' => 'Invalid card number', 'unknow_transmitter' => 'Unknow transmitter', 'format_error' => 'Format error',
		'expired_card' => 'Expired card', 'fraud_suspected' => 'Fraud suspected', 'lost_card'=>'Lost card', 'stolen_card' => 'Stolen card',
		'unauthorized_transac' => 'Unauthorized transaction', 'security_rules' => 'Security rules non respected', 'server_error' => 'Server error',
		'error_response' => 'error call response\n', 'response_not_found' => 'executable response not found', 'api_error' => 'API call error\n',
		'error_msg' => 'Error message: ', 'accepted' => 'Accepted', 'payment_pending' => 'Payment is pending',	'pending' => 'Pending',
		'cannot_run_binaries' => 'It seems that the safe mode option of php is active. You are not able to run binairies files into the specified upload folder. Try to use this one: ',
		'path_too_long' => 'The cancel url is probably too long and will cause errors. Please change it to a shorter one. (Actual url: %s - Maximum size: 78)',
		'cancel_path_too_long' => 'The cancel url is probably too long and will cause errors. Please change it to a shorter one. (Actual url: %s - Maximum size: 78)',
		'return_path_too_long' => 'The return url is probably too long and will cause errors. Please change it to a shorter one. (Actual url: %s - Maximum size: 78)',
		'upload_path_too_long' => 'The path to the folder where files have to be uploaded is probably too long and will cause errors. Please change it to a shorter one. (Actual path: %s - Maximum size: 78)',
		'autoresponse_cannot_be_created' => 'The autoresponse file doesn\'t exists and cannot be generated. Please read the documentation to see how to create this file.',
		'logo_path_outside' => 'Wrong logo folder path. The logo folder have to be inside the website folder.',
		'error_copy_logos' => 'Error: one or more pictures cannot be copied in the specified folder. Please copy these pictures from %s to %s via FTP',
		'wrong_file' => 'Error: wrong file uploaded', 'binary_folder_not_exists' => 'The specified folder for binary files doesn\'t exist (%s',
		'request_not_exists' => 'The request file doesn\'t exist (%srequest', 'response_not_exists' => 'The request file doesn\'t exist (%sresponse',
		'certif_not_exists' => 'The certificate file doesn\'t exist ( %s ).', 'logo_folder_error' => 'The specified folder for cards\' pictures doesn\'t exist (%s)',
		'file_x_not_exists' => 'The %s file doesn\'t exist (%s)', 'file_generated' => ' This file name has been automatically generated using your merchant id so please verify it!',
		'param_folder_not_exists' => 'The specified folder for parameters files doesn\'t exist (%s)',
		'wrong_path_to_x' => 'The path to the %s in your pathfile is not the same as the one you specified here (Found: %s. It should be: %s)',
		'safe_mode_activated' => 'It seems that the safe mode option of php is active. You have to upload manually (for example via FTP) the binary files (request, response) and the parameters files (pathfile, parcom.[service], certif.xx.xxxxxxxxxxxxx and parmcom.xxxxxxxxxxxxx). Please specify the folder where this files are uploaded to allow a validation.',
		'missing_merchant_coutry' => 'Please specify your merchant country before uploading your certificate',
		'missing_merchant_id' => 'Please specify your merchant id before uploading your certificate',
		'copy_logo' => 'The specified logo folder is empty. Please copy this pictures from %s to %s'
	);

	var $messageFr = array(
		'invalid_transaction' => 'Transaction invalide', 'invalid_amount' => 'Montant invalide', 'refused_payment' => 'Paiement refusee',
		'invalid_card_number' => 'Numero de carte non valide', 'unknow_transmitter' => 'Emetteur de carte inconnu', 'format_error' => 'Erreur de format',
		'expired_card' => 'Carte expiree', 'fraud_suspected' => 'Fraude suspectee', 'lost_card'=>'Carte perdue', 'stolen_card' => 'Carte volee',
		'unauthorized_transac' => 'Transaction non autorisee', 'security_rules' => 'Regles de securite non respectes', 'serveur_error' => 'Erreur du serveur',
		'error_response' => 'erreur appel response\n', 'response_not_found' => 'executable response non trouve',
		'api_error' => 'Erreur lors de l\'appel de l\'API\n', 'error_msg' => 'Message d\'erreur: ',	'accepted' => 'Accepte', 'payment_pending' => 'Paiement en attente',
		'pending' => 'En attente',
		'cannot_run_binaries' => 'Il semble que le safe mode de php soit actif, vous n\'etes donc pas autorise a executer les fichiers binaires dans le dossier specifie. Essayez avec celui-ci: ',
		'cancel_path_too_long' => 'L\'url d\annulation est trop longue et peut causer des erreurs. Changez la pour une url plus courte. (Actuelement: %s - Taille maximum: 78)',
		'return_path_too_long' => 'L\'url de retour est trop longue et peut causer des erreurs. Changez la pour une url plus courte. (Actuelement: %s - Taille maximum: 78)',
		'upload_path_too_long' => 'Le chemin vers le dossier de téléchargement est trop long et peut causer des erreurs. Changez le pour une chemin plus courte. (Actuelement: %s - Taille maximum: 78)',
		'autoresponse_cannot_be_created' => 'Le fichier de reponse automatique n\'existe pas et ne peut pas être créé. Veuillez vous référer à la documentation pour savoir comment créer ce fichier.',
		'logo_path_outside' => 'Le chemin du dossier des logos est incorrect. Ce dossier doit être à l\interieur de votre dossier principal (dossier du site).',
		'error_copy_logos' => 'Erreur: une ou plusieurs images ne peuvent être copiées dans le dossier spécifié. Veuillez copier ces images du dossier %s au dossier %s.',
		'wrong_file' => 'Erreur: le fichier séléctionné n\'est pas celui demandé', 'binary_folder_not_exists' => 'Le dossier spécifié pour les fichiers binaires n\'existe pas (%s',
		'request_not_exists' => 'Le fichier request n\'existe pas (%srequest', 'response_not_exists' => 'Le fichier response n\'existe pas (%sresponse',
		'certif_not_exists' => 'Le fichier de certificat n\'existe pas ( %s ).', 'logo_folder_error' => 'Le dossier spécifié pour les logos de carte n\'existe pas (%s)',
		'file_x_not_exists' => 'Le fichier %s n\'existe pas (%s)', 'file_generated' => ' Ce nom de fichier a été détecté en utilisant votre id marchant. Verifiez donc que ce dernier est bon!',
		'param_folder_not_exists' => 'Le dossier spécifié pour les fichiers de paramètre n\'existe pas (%s)',
		'wrong_path_to_x' => 'Le chemin vers le %s trouvé dans votre fichier pathfile n\'est pas le même que celui que vous avez spécifié ici (Trouvé: %s. Cela devrait être: %s)',
		'safe_mode_activated' => 'Il semble que le safe mode de php soit activé. Vous devez donc télécharger manuellement (par exemple par FTP) les fichiers binaires (request, reponse) ainsi que les fichiers de parametres (pathfile, parcom.e-transaction, certif.xx.xxxxxxxxxxxxxxx et parcom.xxxxxxxxxxxxxxxx). Merci de spécifier les dossiers où ces fichiers seront téléchargés de façon à valider vos paramètres.',
		'missing_merchant_coutry' => 'Merci de préciser votre pays avant de télécharger votre certificat',
		'missing_merchant_id' => 'Merci de préciser votre id marchand avant de télécharger votre certificat',
		'copy_logo' => 'Le dossier spécifié pour les logos de carte est vide. Merci de copier les images necessaire du dossier %s vers le dossier %s'
	);
    
	public function __construct(&$subject, $config = array())
	{
		$config = array_merge($config, array(
				'ppName'		=> 'atos',
				'ppKey'			=> 'PLG_INVOICINGPAYMENT_ATOS_TITLE',
				'ppImage'		=> JURI::root().'plugins/invoicingpayment/atos/atos/atos.jpg')
		);
	
		parent::__construct($subject, $config);
	}
	
	function onInvoicingPaymentDisplay($paymentmethod,$data)
	{	
		if($paymentmethod != $this->ppName) return false;
		
		$app = JFactory::getApplication();
		$db =JFactory::getDbo();
		$user = JFactory::getUser();
		
		$this->baseurl = JURI::base();

		$params = array();
		
		$params['merchantId']         = $this->params->get('merchant_id','');
        $params['merchantCountry']    = $this->params->get('merchant_country','');

		$currency =  FOFModel::getTmpInstance('Currencies', 'InvoicingModel')->getItem($data->currency_id);

        $params['currencyCode']       = @$this->sync_currencies[$currency->code];
        
        $params['paymentMeans']       = $this->params->get('payment_means','CB,2,VISA,2,MASTERCARD,2');
		$params['debug']			  = $this->params->get('debug',0);
		//$params['template']			  = $this->params->get('template','');
        
        $params['binFolder']          = JPATH_ROOT.$this->params->get('certificat_folder','/plugins/invoicingpayment/atos/');
		$params['logoFolder']  		  = JURI::base().$this->params->get('logo_folder','/plugins/invoicingpayment/atos/atos/logo/');
        
		$this->_generateFiles($params);
		$this->_checkFiles($params);
		
		$lang = JFactory::getLanguage();
		$locale=strtolower(substr($lang->get('tag'),0,2));
		
		// an invoice is generated using the date and time
		$invoice	= $data->invoicing_invoice_id;
		// a sequence number is randomly generated
		$sequence	= rand(1, 1000);
		// a timestamp is generated
		$timeStamp	= time();
		
		$this->item_name = InvoicingHelperFormat::formatOrderNumber($data);
		
		include(dirname(__FILE__)."/atos/payment.php");
	}

	function _generateFiles(&$params){
		$app = JFactory::getApplication();
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.path');
		if($params['debug'] == 1 )
			$debug='YES';
		else
			$debug='NO';
		if(empty($params['merchantId'])){
			return true;
		}
		$message=$this->_getLanguage();

		$logoPath=JURI::base(true).$params['logoFolder'];
		$logoPath=str_replace('administrator','',$logoPath);

		$safe_mode = ini_get('safe_mode') == 1 || !strcasecmp(ini_get('safe_mode'), 'On');


		$lang = JFactory::getLanguage();
		$locale=strtolower(substr($lang->get('tag'),0,2));

	/*	$atos='<?php
$_GET[\'option\']=\'com_invoicing\';
$_GET[\'tmpl\']=\'component\';
$_GET[\'notif_payment\']=\'atos\';
$_GET[\'lang\']=\''.$locale.'\';
$_REQUEST[\'option\']=\'com_invoicing\';
$_REQUEST[\'tmpl\']=\'component\';
$_REQUEST[\'notif_payment\']=\'atos\'	;
$_REQUEST[\'lang\']=\''.$locale.'\';
include(\'index.php\');
';
		$success='<?php header("Location: index.php?option=com_invoicing&task=after_end");';
*/
		//$path=$this->_addLastSlash($path);
		$pathfile='DEBUG!'.$debug.'!'."\r\n".'D_LOGO!'.$params['logoFolder'].'!'."\r\n".
				'F_DEFAULT!'.$params['binFolder'].'pc.x!'."\r\n".
				'F_PARAM!'.$params['binFolder'].'pc!'."\r\n".
		//		'F_CTYPE!php!'."\r\n".
				'F_CERTIFICATE!'.$params['binFolder'].'certif!'."\r\n";
		$parcom='ADVERT!'.$params['advert'].'!'."\r\n";

		$pc='';
		JFile::write($params['binFolder'].'pc.x', $parcom);
		JFile::write($params['binFolder'].'pc.'.$params['merchantId'], $pc);

		JFile::write($params['binFolder'].'pathfile', $pathfile);
//echo $path.'pathfile' ;exit();
		/*$rights=JPath::getPermissions(JPATH_ROOT);
		if($rights[1]!='w' && !(JFile::exists(JPATH_ROOT.DS.'atos.php'))){
			$app->enqueueMessage( $message['autoresponse_cannot_be_created'], 'error');
			return true;
		}*/
		//JFile::write(JPATH_ROOT.DS.'atos.php',$atos);
		//JFile::write(JPATH_ROOT.DS.'success.php',$success);

	}
	
	function _getLanguage(){
		$lang = JFactory::getLanguage();
		$locale=strtolower(substr($lang->get('tag'),0,2));

		if($locale=='fr')
			return ($this->messageFr);
		return ($this->messageEng);
	}
	
	function _checkFiles(&$params){
		$app = JFactory::getApplication();
		jimport('joomla.filesystem.file');
		$fail=false;
		$message=$this->_getLanguage();

		$os=substr(PHP_OS, 0, 3);
		$os=strtolower($os);

		$path = $params['binFolder'];

		//$path=$this->_addLastSlash($path);

		if($os=='win'){
			if(!JFile::exists($path.'request.exe')){
				$app->enqueueMessage( sprintf($message['request_not_exists'], $path).'.exe)', 'error');
				$fail=true;
			}
			else{
				$request_exist=true;
			}
			if(!JFile::exists($path.'response.exe')){
				$app->enqueueMessage( sprintf($message['response_not_exists'], $path).'.exe)', 'error');
				$fail=true;
			}
			else{
				$response_exist=true;
			}
		}
		else{
			if(!JFile::exists($path.'request')){
				$app->enqueueMessage( sprintf($message['request_not_exists'],$path).')', 'error');
				$fail=true;
				$request_exist=false;
			}
			else{
				$request_exist=true;
			}
			if(!JFile::exists($path.'response')){
				$app->enqueueMessage( sprintf($message['request_not_exists'], $path).')', 'error');
				$fail=true;
				$response_exist=false;
			}
			else{
				$response_exist=true;
			}
		}
		if($params['merchantCountry'] != '')
			$merchantCountry=strtolower($params['merchantCountry']);
		if(!JFile::exists($path.'certif.'.$merchantCountry.'.'.$params['merchantId'])){
			if($merchantCountry != '' && $params['merchantId'] != ''){
				$app->enqueueMessage( sprintf($message['certif_not_exists'], $path.'certif.'.$merchantCountry.'.'.$params['merchantId']).$message['file_generated'], 'error');;
				$fail=true;
				$certif_exist=false;
			}
			else{
				$app->enqueueMessage( sprintf($message['certif_not_exists'], $path.'certif.[merchant_country].[merchant_id]').$message['file_generated'], 'error');
				$fail=true;
				$certif_exist=false;
			}
		}
		else{
			$certif_exist=true;
		}
		if($fail)
			return false;
		return true;
	}
	
	function onInvoicingPaymentNotification($paymentmethod, $data) {

		// Check if we're supposed to handle this
		if($paymentmethod != $this->ppName) return false;
		
		InvoicingHelperLog::log("Process ATOS");
		
		$app = JFactory::getApplication();
		$db =JFactory::getDBO();
		
		$output = "";

		// Récupération de la variable cryptée DATA
		$message="message=".JRequest::getVar('DATA');

		// Initialisation du chemin du fichier pathfile (à modifier)
			//   ex :
			//    -> Windows : $pathfile="pathfile=c:/repertoire/pathfile"
			//    -> Unix    : $pathfile="pathfile=/home/repertoire/pathfile"
		$os=substr(PHP_OS, 0, 3);
		$os=strtolower($os);
		$params = array();
		$params['binFolder']          = JPATH_ROOT.$this->params->get('certificat_folder','/plugins/invoicingpayment/atos/');
		$pathfile="pathfile=".$params['binFolder']."pathfile";

		//Initialisation du chemin de l'executable response (à modifier)
		//ex :
		//-> Windows : $path_bin = "c:/repertoire/bin/response"
		//-> Unix    : $path_bin = "/home/repertoire/bin/response"
		//
		if($os=='win')
			$path_bin = $params['binFolder']."response.exe";
		else
			$path_bin = $params['binFolder']."response";

		// Appel du binaire response
	  	$message = escapeshellcmd($message);
	  	$result=exec("$path_bin $pathfile $message");

		//	Sortie de la fonction : !code!error!v1!v2!v3!...!v29
		//		- code=0	: la fonction retourne les données de la transaction dans les variables v1, v2, ...
		//				: Ces variables sont décrites dans le GUIDE DU PROGRAMMEUR
		//		- code=-1 	: La fonction retourne un message d'erreur dans la variable error


		//	on separe les differents champs et on les met dans une variable tableau

		$tableau = explode ("!", $result);

		$code = $tableau[1];
		$error = $tableau[2];
		$merchant_id = $tableau[3];
		$merchant_country = $tableau[4];
		$amount = $tableau[5];
		$transaction_id = $tableau[6];
		$payment_means = $tableau[7];
		$transmission_date= $tableau[8];
		$payment_time = $tableau[9];
		$payment_date = $tableau[10];
		$response_code = $tableau[11];
		$payment_certificate = $tableau[12];
		$authorisation_id = $tableau[13];
		$currency_code = $tableau[14];
		$card_number = $tableau[15];
		$cvv_flag = $tableau[16];
		$cvv_response_code = $tableau[17];
		$bank_response_code = $tableau[18];
		$complementary_code = $tableau[19];
		$complementary_info= $tableau[20];
		$return_context = $tableau[21];
		$caddie = $tableau[22];
		$receipt_complement = $tableau[23];
		$merchant_language = $tableau[24];
		$language = $tableau[25];
		$customer_id = $tableau[26];
		$order_id = $tableau[27];
		$customer_email = $tableau[28];
		$customer_ip_address = $tableau[29];
		$capture_day = $tableau[30];
		$capture_mode = $tableau[31];
		$data = $tableau[32];
		$order_validity = $tableau[33];
		$transaction_condition = $tableau[34];
		$statement_reference = $tableau[35];
		$card_validity = $tableau[36];
		$score_value = $tableau[37];
		$score_color = $tableau[38];
		$score_info = $tableau[39];
		$score_threshold = $tableau[40];
		$score_profile = $tableau[41];
		
		$currency  = null;
		foreach($this->sync_currencies as $key => $value) {
			if ($value == $currency_code) {
				$currency = $key;
			}
		}
		
		$amount = $amount / 100;
		
		ob_start();

        if (( $code == "" ) && ( $error == "" ) )
	 	{
	  		print ("<BR><CENTER>erreur appel response</CENTER><BR>");
	  		print ("executable response non trouve $path_bin");
	  		$isValid = false;
	 	}

		//	Erreur, affiche le message d'erreur

		else if ( $code != 0 ){
			print ("<center><b><h2>Erreur appel API de paiement.</h2></center></b>");
			print ("<br><br><br>");
			print (" message erreur : $error <br>");
			$isValid = false;
		}

		// OK, affichage des champs de la réponse
		else {
		
			# OK, affichage du mode DEBUG si activé
			print (" $error <br>");
		
			print("<center>\n");
			print("<H3>R&eacute;ponse manuelle du serveur SOGENACTIF</H3>\n");
			print("</center>\n");
			print("<b><h4>\n");
			print("<br><hr>\n");
			print("<br>merchant_id : $merchant_id\n");
			print("<br>merchant_country : $merchant_country\n");
			print("<br>amount : $amount\n");
			print("<br>transaction_id : $transaction_id\n");
			print("<br>transmission_date: $transmission_date\n");
			print("<br>payment_means: $payment_means\n");
			print("<br>payment_time : $payment_time\n");
			print("<br>payment_date : $payment_date\n");
			print("<br>response_code : $response_code\n");
			print("<br>payment_certificate : $payment_certificate\n");
			print("<br>authorisation_id : $authorisation_id\n");
			print("<br>currency_code : $currency_code\n");
			print("<br>currency : $currency\n");
			print("<br>card_number : $card_number\n");
			print("<br>cvv_flag: $cvv_flag\n");
			print("<br>cvv_response_code: $cvv_response_code\n");
			print("<br>bank_response_code: $bank_response_code\n");
			print("<br>complementary_code: $complementary_code\n");
			print("<br>complementary_info: $complementary_info\n");
			print("<br>return_context: $return_context\n");
			print("<br>caddie : $caddie\n");
			print("<br>receipt_complement: $receipt_complement\n");
			print("<br>merchant_language: $merchant_language\n");
			print("<br>language: $language\n");
			print("<br>customer_id: $customer_id\n");
			print("<br>order_id: $order_id\n");
			print("<br>customer_email: $customer_email\n");
			print("<br>customer_ip_address: $customer_ip_address\n");
			print("<br>capture_day: $capture_day\n");
			print("<br>capture_mode: $capture_mode\n");
			print("<br>data: $data\n");
			print("<br>order_validity: $order_validity\n");
			print("<br>transaction_condition: $transaction_condition\n");
			print("<br>statement_reference: $statement_reference\n");
			print("<br>card_validity: $card_validity\n");
			print("<br>card_validity: $score_value\n");
			print("<br>card_validity: $score_color\n");
			print("<br>card_validity: $score_info\n");
			print("<br>card_validity: $score_threshold\n");
			print("<br>card_validity: $score_profile\n");
			print("<br><br><hr></b></h4>");
			
			$isValid = true;		
				
			if ($this->checkValidity($order_id,$amount,true,strtoupper($currency)) == true) {
				$this->validPayment($order_id,$paymentmethod);
			} else {
				InvoicingHelperLog::log("Error checkValidity : $order_id, $amount,$currency");
				$isValid = false;
			}
		}
		$out = ob_get_clean();

		InvoicingHelperLog::log($out);

		// Fraud attempt? Do nothing more!
		if(!$isValid) return false;
	}
}
