<?php
/**
 * @package		Invoicing
 * @copyright	Copyright (C) 2010-2014 Juloa.com. All rights reserved.
 * @license GNU General Public License version 3, or later
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

require_once(JPATH_ADMINISTRATOR.'/components/com_invoicing/assets/paymentplugin.php');


class plgInvoicingpaymentPaybox extends InvoicingAbstractPaymentPlugin
{
	public function __construct(&$subject, $config = array())
	{
		if(version_compare(JVERSION, '1.6', 'ge')) {
			$defaultimg = JURI::root().'plugins/invoicingpayment/paypal/paypal/paypal.jpg';
		} else {
			$defaultimg = JURI::root().'plugins/invoicingpayment/paypal/paypal.jpg';
		}	
		
		$config = array_merge($config, array(
			'ppName'		=> 'paybox',
			'ppKey'			=> 'PLG_INVOICINGPAYMENT_PAYBOX_TITLE',
			'ppImage'		=> JURI::root().'plugins/invoicingpayment/paypal/paypal/paypal.jpg')
				);
		
		parent::__construct($subject, $config);
	}
	
	function onInvoicingPaymentDisplay($paymentmethod,$data)
	{	
		if($paymentmethod != $this->ppName) return false;
		
		$item =  FOFModel::getTmpInstance('Invoices', 'InvoicingModel')->getItem($data->invoicing_invoice_id);
		$item->save(array("processor"=>'offline'));
		

		$this->config = new stdClass();
		$this->config->langue = $this->params->get('langue','FRA');
		$this->config->site = $this->params->get('site','1999888');
		$this->config->rang = $this->params->get('rang','32');
		$this->config->secret_key = $this->params->get('secret_key','0123456789ABCDEF0123456789ABCDEF0123456789ABCDEF0123456789ABCDEF0123456789ABCDEF0123456789ABCDEF0123456789ABCDEF0123456789ABCDEF');
		$this->config->identifiant = $this->params->get('identifiant','107904482');
		$this->config->sandbox = $this->params->get('sandbox',0);
		$this->config->devise = $this->params->get('devise',978);

		$this->config->porteur = $data->buyer->email;

		
		
		$PBX_LANGUE =$this->config->langue;
		$PBX_SITE =$this->config->site; // Site Paybox
		$PBX_RANG =$this->config->rang; // Rang Paybox
		$PBX_IDENTIFIANT =$this->config->identifiant; // Identifiant Paybox
		$PBX_TOTAL = $data->gross_amount * 100; // la valeur en centième d'euros, soit 1000 = 10,00 € *
		$PBX_DEVISE =$this->config->devise;
		$PBX_CMD =$data->invoicing_invoice_id; // Le numéro de la commande *
		$PBX_PORTEUR = $this->config->porteur;
		$PBX_RETOUR = 'amount:M;order:R;trans:T;tran:S;dat:D;error:E;idtrans:S;sign:K';
		//Mt:M;Ref:R;Auto:A;Erreur:E
		$PBX_EFFECTUE = JURI::base().'index.php?option=com_invoicing&task=message&msg=complete';
		$PBX_REFUSE = JURI::base().'index.php?option=com_invoicing&task=message&msg=cancel';
		$PBX_ANNULE = JURI::base().'index.php?option=com_invoicing&task=message&msg=cancel';
		$PBX_REPONDRE_A = JURI::base().'index.php?option=com_invoicing&task=process&type=paybox';
		
		// On crée la chaîne à hacher sans URLencodage
		$msg = "PBX_SITE=$PBX_SITE".
				"&PBX_RANG=$PBX_RANG".
				"&PBX_IDENTIFIANT=$PBX_IDENTIFIANT".
				"&PBX_TOTAL=".$PBX_TOTAL.
				"&PBX_DEVISE=$PBX_DEVISE".
				"&PBX_CMD=".$PBX_CMD.
				"&PBX_PORTEUR=".$PBX_PORTEUR.
				"&PBX_RETOUR=$PBX_RETOUR".
				"&PBX_TYPEPAIEMENT=CARTE".
				"&PBX_TYPECARTE=CB".
				"&PBX_HASH=SHA512".
				"&PBX_RUF1=POST".
				"&PBX_TIME=".$dateTime.
				"&PBX_EFFECTUE=".$PBX_EFFECTUE.
				"&PBX_REFUSE=".$PBX_REFUSE.
				"&PBX_ANNULE=".$PBX_ANNULE.
				"&PBX_REPONDRE_A=".$PBX_REPONDRE_A;
		
		// On récupère la clé secrète HMAC (stockée dans une base de données par exemple) et que l’on renseigne dans la variable $keyTest;
		// Si la clé est en ASCII, On la transforme en binaire
		$binKey = pack("H*", $this->config->secret_key);
		
		// On calcule l’empreinte (à renseigner dans le paramètre PBX_HMAC) grâce à la fonction hash_hmac et
		// la clé binaire
		// On envoie via la variable PBX_HASH l'algorithme de hachage qui a été utilisé (SHA512 dans ce cas)
		// Pour afficher la liste des algorithmes disponibles sur votre environnement, décommentez la ligne
		// suivante
		// print_r(hash_algos());
		$hmac = strtoupper(hash_hmac('sha512', $msg, $binKey));
		
		if ($this->config->sandbox == 1) {
			$URL_PAYBOX = 'https://preprod-tpeweb.paybox.com/cgi/MYchoix_pagepaiement.cgi';
		} else {
			$URL_PAYBOX = 'https://tpeweb.paybox.com/cgi/MYchoix_pagepaiement.cgi';
		}
		
		@ob_start();
		include dirname(__FILE__).'/paybox/form.php';
		$html = @ob_get_clean();
		
        return $html;
	}
	
	public function onInvoicingPaymentNotification($paymentmethod, $data) {
		// Check if we're supposed to handle this
		if($paymentmethod != $this->ppName) return false;
		
		JLoader::import('joomla.utilities.date');
		
		// Check if we're supposed to handle this
		if($paymentmethod != $this->ppName) return false;
		
		$query_string =  'amount='.$data['amount'].'&order='.$data['order'].'&trans='.$data['trans'].'&tran='.$data['tran'].'&dat='.$data['dat'].'&error='.$data['error'].'&idtrans='.$data['idtrans'].'&sign='.str_replace(" ","+",$data['sign']);
		echo $query_string;
		$signtest = $this->PbxVerSign($query_string, dirname(__FILE__)."/paybox/pubkey.pem", 0 );
		echo "Signature OK=".$signtest;
		//$signtest = 1;
		
		$isValid = true;
		
		$error = JRequest::getVar('error','');
		$order_id = JRequest::getInt('order',0);
		$payment_amount = JRequest::getInt('amount',0) / 100;
		if (($signtest == 1)&&($error == '00000')) {
			$isNetAmount = true;
			if ($this->checkValidity($order_id,$payment_amount,$isNetAmount,$currency) == true) {
				$this->validPayment($order_id,$paymentmethod);
			} else {
				$isValid = false;
			}
		} else {
			$isValid = false;
		}
		
		// Fraud attempt? Do nothing more!
		if(!$isValid) return false;
	}

	protected function LoadKey( $keyfile, $pub=true, $pass='' ) {         // chargement de la clé (publique par défaut)
	    $fp = $filedata = $key = FALSE;                         // initialisation variables
	    $fsize =  filesize( $keyfile );                         // taille du fichier
	    if( !$fsize ) return FALSE;                             // si erreur on quitte de suite
	    $fp = fopen( $keyfile, 'r' );                           // ouverture fichier
	    if( !$fp ) return FALSE;                                // si erreur ouverture on quitte
	    $filedata = fread( $fp, $fsize );                       // lecture contenu fichier
	    fclose( $fp );                                          // fermeture fichier
	    if( !$filedata ) return FALSE;                          // si erreur lecture, on quitte
	    if( $pub )
		$key = openssl_pkey_get_public( $filedata );        // recuperation de la cle publique
	    else                                                    // ou recuperation de la cle privee
		$key = openssl_pkey_get_private( array( $filedata, $pass ));
	    return $key;                                            // renvoi cle ( ou erreur )
	}

	// comme precise la documentation Paybox, la signature doit être
	// obligatoirement en dernière position pour que cela fonctionne
	protected function GetSignedData( $qrystr, &$data, &$sig, $url ) {    // renvoi les donnes signees et la signature

	    $pos = strrpos( $qrystr, '&' );                         // cherche dernier separateur
	    $data = substr( $qrystr, 0, $pos );                     // et voila les donnees signees
	    $pos= strpos( $qrystr, '=', $pos ) + 1;                 // cherche debut valeur signature
	    $sig = substr( $qrystr, $pos );                         // et voila la signature

	    if( $url ) $sig = urldecode( $sig );                    // decodage signature url
	    $sig = base64_decode( $sig );                           // decodage signature base 64
//echo $sig;
	}

	// $querystring = chaine entière retournée par Paybox lors du retour au site (méthode GET)
	// $keyfile = chemin d'accès complet au fichier de la clé publique Paybox

	protected function PbxVerSign( $qrystr, $keyfile, $url ) {            // verification signature Paybox

	    $key = $this->LoadKey( $keyfile );                             // chargement de la cle
	    if( !$key ) return -1;                                  // si erreur chargement cle
	//  penser à openssl_error_string() pour diagnostic openssl si erreur
	    $this->GetSignedData( $qrystr, $data, $sig, $url );            // separation et recuperation signature et donnees
//echo "ti=".$sig;
	    return openssl_verify( $data, $sig, $key );             // verification : 1 si valide, 0 si invalide, -1 si erreur
	}
}
