<?php
/**
 * @package		Invoicing
 * @copyright	Copyright (C) 2010-2014 Juloa.com. All rights reserved.
 * @license GNU General Public License version 3, or later
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

require_once(JPATH_ADMINISTRATOR.'/components/com_invoicing/assets/paymentplugin.php');
require_once(JPATH_ADMINISTRATOR.'/components/com_invoicing/helpers/format.php');
require_once(JPATH_ADMINISTRATOR.'/components/com_invoicing/helpers/log.php');

class plgInvoicingpaymentEwire extends InvoicingAbstractPaymentPlugin
{
	public function __construct(&$subject, $config = array())
	{
		$config = array_merge($config, array(
			'ppName'		=> 'ewire',
			'ppKey'			=> 'PLG_INVOICINGPAYMENT_EWIRE_TITLE',
			'ppImage'		=> JURI::root().'plugins/invoicingpayment/ewire/ewire/ewire.jpg')
				);
		
		parent::__construct($subject, $config);
	}
	
	function onInvoicingPaymentDisplay($paymentmethod,$data)
	{	
		if($paymentmethod != $this->ppName) return false;
		
		$app = \JFactory::getApplication();
		$db = \JFactory::getDbo();
		$user		= \JFactory::getUser();
		
		$this->order = $data;	
		
		$this->config = new \stdClass();
		$this->config->companyId =  $this->params->get('companyId','');
		$this->config->privateKey =  $this->params->get('privateKey','');
		$this->config->language =  $this->params->get('language','');
		
		$currencyModel = InvoicingModelCurrencies::getInstance('Currencies', 'InvoicingModel');
		$currency =  $currencyModel->getItem($data->currency_id);
		$this->currency_code = $currency->code;
		
		$this->baseurl = JURI::base();
		
		$description = InvoicingHelperFormat::formatOrderNumber($data);
	
		include(dirname(__FILE__)."/ewire/payment.php");
	}

	public function onInvoicingPaymentNotification($paymentmethod, $data)  {

		// Check if we're supposed to handle this
		if($paymentmethod != $this->ppName) return false;
				
		InvoicingHelperLog::log("Process Ewire");
		
		$app = \JFactory::getApplication();
		$db = \JFactory::getDBO();
		
		$this->config = new \stdClass();
		$this->config->companyId =  $this->params->get('companyId','');
		$this->config->privateKey =  $this->params->get('privateKey','');
		$this->config->language =  $this->params->get('language','');
		
		$paidsystem_config = $this->config;
		
		$input = \JFactory::getApplication()->input;
		$posts = "";
		foreach ($input->get->post->getArray() as $key => $value) {
			$posts .= "$key => $value\r\n";
		}
	
		InvoicingHelperLog::log($posts);
		
		
		// Include ewire class
		include_once("ewire/ewirePayment.class.php");
		
		// Create instance of ewire class
		$EWIRE = new ewirePayment();
		$EWIRE->companyId = $paidsystem_config->companyId;
		$EWIRE->encryptionkey = $paidsystem_config->privateKey;
		
		// Retreive values from URL
		$ewireTicket = $_GET["ewireTicket"];			// This is the ewire ticket that you need to renew, complete or cancel the transaction
		$customerOrderId = $_GET["customerOrderId"];	// This is your order id
		$validateMD = $_GET["validateMD"];
		
		// Security check. If theese values does not match, someone is trying to tamper with the order
		$postTransactionCheck = md5($EWIRE->encryptionkey . $customerOrderId . $ewireTicket);
		
		// Show message if security is breached
		if ($postTransactionCheck != $validateMD) {
			$this->_save_log("Security issue. Do not complete the order.<br>");
			exit;
		} else {
			$this->_save_log("valid order");
		}
	
		$this->validPayment($customerOrderId,$paymentmethod);
	}
}
