<?php
defined ('_JEXEC') or die('Restricted access');

require_once(JPATH_ADMINISTRATOR.'/components/com_invoicing/assets/paymentplugin.php');
require_once(JPATH_ROOT.'/plugins/invoicingpayment/midtrans/midtrans/Veritrans.php');
require_once(JPATH_ADMINISTRATOR.'/components/com_invoicing/helpers/log.php');

class plgInvoicingpaymentMidtrans extends InvoicingAbstractPaymentPlugin {

    public function __construct(&$subject, $config = array())
	{
		if(version_compare(JVERSION, '1.6', 'ge')) {
			$defaultimg = JURI::root().'plugins/invoicingpayment/midtrans/midtrans/midtrans.jpg';
		} else {
			$defaultimg = JURI::root().'plugins/invoicingpayment/midtrans/midtrans.jpg';
		}

		$config = array_merge($config, array(
			'ppName'		=> 'midtrans',
			'ppKey'			=> 'PLG_INVOICINGPAYMENT_MIDTRANS_TITLE',
			'ppImage'		=> $defaultimg)
				);

		parent::__construct($subject, $config);
	}

	public function onInvoicingPaymentSelection($item) {

		$app = \JFactory::getApplication();
		$db = \JFactory::getDbo();

		//"VT-server-hF_tVNXUXgMflLFGtPx2CMOR";//"VT-server-6iqA9EYn3GW2NZxAZAzKlLMl";//
        Veritrans_Config::$serverKey = $this->params->get('serverkey', '');
		// Uncomment for production environment
		if ( $this->params->get('sandbox', '') == 1) {
			Veritrans_Config::$isProduction = false;
			$snapUrl = 'https://app.sandbox.midtrans.com/snap/snap.js';
		} else {
			Veritrans_Config::$isProduction = true;
			$snapUrl = 'https://app.midtrans.com/snap/snap.js';
		}
		Veritrans_Config::$isSanitized = false;
        Veritrans_Config::$is3ds = false;

       // include_once(JPATH_ROOT.'/administrator/components/com_invoicing/helpers/Format.php');

        $transaction_details = array(
            'order_id' => $item->invoicing_invoice_id,
            'gross_amount' => (int)$item->gross_amount, // no decimal allowed for creditcard
        );

        $item_details = array();
		foreach($item->items as $value) {
			$object = array(
				'id' => $value->invoicing_invoice_item_id,
				'price' => (int)$value->gross_unit_price,
				'quantity' => $value->quantity,
				'name' => $value->description,
			);
			$item_details[] = $object;
		}

		$uri	= JURI::getInstance();
		$base	= $uri->toString( array('scheme', 'host', 'port'));

        $transaction = array(
            'transaction_details' => $transaction_details,
			'item_details' => $item_details,
        );

		$snapToken = Veritrans_Snap::getSnapToken($transaction);
		//echo $snapToken;

		ob_start();
		?>
		<script src="<?php echo $snapUrl; ?>"></script>
		<div class="paymentMeth mt-3" id="midtrans_button">
				<a href="javascript:void(0);" class="paymentbutton">
					<div class="paymentImg ">
						<img class="img-responsive" width="80" src="<?= JURI::base()?>/plugins/invoicingpayment/midtrans/midtrans/midtrans.png"></div>
					<div class="paymentTxt"><?php echo $this->params->get('title', 'Pay with MidTrans!!');?></div>
				</a>
		</div>
		<?php
			 $complete = \JRoute::_('index.php?option=com_invoicing&view=message&layout=complete');
			 $error = \JRoute::_('index.php?option=com_invoicing&view=message&layout=error');
		?>
		<?php
			$script = "
			jQuery('#midtrans_button').click(function() {
				snap.pay('".$snapToken."', {
					 onSuccess: function(result){console.log('success');window.location='".$complete."';},
					 onPending: function(result){console.log('pending');window.location='".$complete."';},
					 onError: function(result){console.log('error');window.location='".$error."';},
					 onClose: function(){console.log('customer closed the popup without finishing the payment');}
				});
			});";

			\JFactory::getApplication()->getDocument()->addScriptDeclaration($script);
		?>
		<?php
		$html = ob_get_clean();
		return $html;

	}

    function onInvoicingPaymentDisplay($paymentmethod,$data)
	{
		$app = \JFactory::getApplication();
		$db = \JFactory::getDbo();

		//"VT-server-hF_tVNXUXgMflLFGtPx2CMOR";//"VT-server-6iqA9EYn3GW2NZxAZAzKlLMl";//
        Veritrans_Config::$serverKey = $this->params->get('serverkey', '');
		// Uncomment for production environment
		if ( $this->params->get('sandbox', '') == 1) {
			Veritrans_Config::$isProduction = false;
			$snapUrl = 'https://app.sandbox.midtrans.com/snap/snap.js';
		} else {
			Veritrans_Config::$isProduction = true;
			$snapUrl = 'https://app.midtrans.com/snap/snap.js';
		}
		Veritrans_Config::$isSanitized = false;
        Veritrans_Config::$is3ds = false;

       // include_once(JPATH_ROOT.'/administrator/components/com_invoicing/helpers/Format.php');

        $transaction_details = array(
            'order_id' => $data->invoicing_invoice_id,
            'gross_amount' => (int)$data->gross_amount, // no decimal allowed for creditcard
        );

        $item_details = array();
		foreach($data->items as $value) {
			$object = array(
				'id' => $value->invoicing_invoice_item_id,
				'price' => (int)$value->gross_unit_price,
				'quantity' => $value->quantity,
				'name' => $value->description,
			);
			$item_details[] = $object;
		}

		$uri	= JURI::getInstance();
		$base	= $uri->toString( array('scheme', 'host', 'port'));

        $transaction = array(
            'transaction_details' => $transaction_details,
			'item_details' => $item_details,
        );

		$snapToken = Veritrans_Snap::getSnapToken($transaction);
		//echo $snapToken;

		ob_start();
		?>
		<script src="<?php echo $snapUrl; ?>"></script>
		<p>
            Payment gateway loading...
        </p>
		<?php
			 $complete = \JRoute::_('index.php?option=com_invoicing&view=message&layout=complete');
			 $error = \JRoute::_('index.php?option=com_invoicing&view=message&layout=error');

			 $script = "
			 jQuery(document).ready(function(){
					snap.pay('".$snapToken."', {
						onSuccess: function(result){console.log('success');window.location='".$complete."';},
						onPending: function(result){console.log('pending');window.location='".$complete."';},
						onError: function(result){console.log('error');window.location='".$error."';},
						onClose: function(){console.log('customer closed the popup without finishing the payment');}

					});
				});";

				\JFactory::getApplication()->getDocument()->addScriptDeclaration($script);
		?>
		<?php
		$html = ob_get_clean();
		return $html;
	}

    public function onInvoicingPaymentNotification($paymentmethod, $data)
	{
		if($paymentmethod != $this->ppName) return false;

		if ( $this->params->get('sandbox', '') == 1) {
			Veritrans_Config::$isProduction = false;
		} else {
			Veritrans_Config::$isProduction = true;
		}
		Veritrans_Config::$serverKey = $this->params->get('serverkey', '');

		$notif = new Veritrans_Notification();
		$transaction = $notif->transaction_status;
		$type = $notif->payment_type;
		$order_id = $notif->order_id;
		$fraud = $notif->fraud_status;

		if ($transaction == 'capture') {
		  // For credit card transaction, we need to check whether transaction is challenge by FDS or not
		  if ($type == 'credit_card'){
			if($fraud == 'challenge'){
			  // TODO set payment status in merchant's database to 'Challenge by FDS'
			  // TODO merchant should decide whether this transaction is authorized or not in MAP
			  InvoicingHelperLog::log("Transaction order_id: " . $order_id ." is challenged by FDS");
			  }
			  else {
			  // TODO set payment status in merchant's database to 'Success'
			  InvoicingHelperLog::log("Transaction order_id: " . $order_id ." successfully captured using " . $type);
				$this->validPayment($order_id,$paymentmethod);
			  }
			}
		  }
		else if ($transaction == 'settlement'){
		  // TODO set payment status in merchant's database to 'Settlement'
		  InvoicingHelperLog::log( "Transaction order_id: " . $order_id ." successfully transfered using " . $type);
		  }
		  else if($transaction == 'pending'){
		  // TODO set payment status in merchant's database to 'Pending'
		  InvoicingHelperLog::log( "Waiting customer to finish transaction order_id: " . $order_id . " using " . $type);
		  }
		  else if ($transaction == 'deny') {
		  // TODO set payment status in merchant's database to 'Denied'
		  InvoicingHelperLog::log( "Payment using " . $type . " for transaction order_id: " . $order_id . " is denied.");
		  }
		  else if ($transaction == 'cancel') {
		  // TODO set payment status in merchant's database to 'Denied'
		  InvoicingHelperLog::log( "Payment using " . $type . " for transaction order_id: " . $order_id . " is canceled.");
		}
	}
}
//no close php tag
